/************************************************************************
*                                                                       *
* Copyright (c) 1993                                                    *
* The Regents of The University of Michigan                             *
* Universities Research Association, Inc.                               *
* All Rights Reserved                                                   *
*                                                                       *
*                Authors:                                               *
*                        R. Ball, C. Timmermans, UofM                   *
*                        Y. Takeuchi, T.I.T.                            *
*                        M. Nomachi, KEK                                *
*                        A. Fry, C. Erbas, D. Brenner, SSCL             *
*                                                                       *
************************************************************************/

#include "camlib.h"    /* for just NAF */

#define NTIMES 1
#define BSIZE 10000

error_exit(status)
int status; {
    perror(strerror(status));
    exit(status);
}

int buffer[BSIZE];
/* Main */
main() {
    int status, i, q, x, ii, z,mode;
    short j;
    int slot,function,address;

/* Initialization part */
    status = CAM_Open( );
    if( status ) error_exit(status);
    printf("CAM_Open : OK\n");
    status = CSETBR(0);
    if( status ) error_exit(status);
    printf("CSETBR   : OK\n");
    status = CSETCR(0);
    if( status ) error_exit(status);
    printf("CSETCR   : OK\n");
    status = CGENZ();
    if( status ) error_exit(status);
    printf("CGENZ    : OK\n");
    status = CGENC();
    if( status ) error_exit(status);
    printf("CGENC    : OK\n");
    status = CSETI();
    if( status ) error_exit(status);
    printf("CSETI    : OK\n");
    status = CREMI();
    if( status ) error_exit(status);
    printf("CREMI    : OK\n");
    i=0xff;
    mode = 0;
    system("date");
    for(ii=0;ii<BSIZE;ii++)buffer[ii]= 800* ii;
    for(i=0;i< NTIMES;i++) 
      if(CBLWAI(mode,NAF(14,1,16),buffer,BSIZE,&ii,&z)) printf("Error %d\n",i);
    system("date");
    for(ii=0;ii<BSIZE;ii++)buffer[ii]= 0;
    for(i=0;i< NTIMES;i++)
      if(CBLWAI(mode,NAF(14,0,0),buffer,BSIZE,&ii,&z)) printf("Error %d\n",i);
    system("date");
    printf("Return_length.... %d %x %x \n",ii,buffer[0],buffer[ii-1]);
}











