/*************************************************
 * ask.c,v
*************************************************/
/*---------------------------------------------------------------*/
/*                                                               */
/*      Donald BRENNER                                           */
/*      Superconducting Super Collider Laboratory                */
/*      June 20, 1992                                            */
/*                                                               */
/*---------------------------------------------------------------*/

/************************************************************************
*                                                                       *
* Copyright (c) 1993                                                    *
* The Regents of The University of Michigan                             *
* Universities Research Association, Inc.                               *
* All Rights Reserved                                                   *
*                                                                       *
*                Authors:                                               *
*                        R. Ball, C. Timmermans, UofM                   *
*                        Y. Takeuchi, T.I.T.                            *
*                        M. Nomachi, KEK                                *
*                        A. Fry, C. Erbas, D. Brenner, SSCL             *
*                                                                       *
************************************************************************/

#include <stdio.h>
#include <sys/types.h>
#include <errno.h>
#include "template.h"
#include "ask.h"

extern char this_node[50];
void askp1();
char proc_name[30],msg[256];

/*(a+out) ------------------------------------------------- */
#ifdef VXWORKS
ask(argv1,argv2,argv3,argv4,argv5,argv6,argv7,
     argv8,argv9,argv10) 
char *argv1,*argv2,*argv3,*argv4,*argv5,*argv6,*argv7,*argv8,*argv9,*argv10;
{
  char *argv[] = {NULL,argv1,argv2,argv3,argv4,argv5,argv6,argv7,argv8,
		    argv9,argv10}; 
  int argc = 11;
#else
main(argc, argv)
int argc;
char * argv[];
{
#endif

   int  index;
   int  msqid, flag;
   char in_string[150];
   int i,j;
   Table entry;

#ifdef VXWORKS
   argv[0] = "ask";
   for(i=0;i<11;i++) {
     if(argv[i] == NULL || *argv[i] == '\0') {
       argc = i;
       break;
     }
   }
#endif
   msg[0] = '\0';
   strcpy(ownpname, "user");

   if (Attach_Table() == -1)
         if (debug_level >= 10) printf("Error in Create_Table()\n");


     if (argc == 1) {
        printf("Which process? ");
        gets(proc_name);
     }
     else
        strcpy(proc_name, argv[1]);

/*                                       */
/* for one process(ie. runcontrol)       */
/*     mult. task(stay in ask runcontrol*/
  
     if (argc <= 2) {
        flag = TRUE;
        while (flag == TRUE) {
           printf("%s > ", proc_name);
           gets(msg);
           if (strncasecmp(msg, "STOP",
                     (strlen(msg) > 1) ? strlen(msg) : 2)  == 0) {
              flag = FALSE;
           }
           else if (strncasecmp(msg, "QUIT",
                     (strlen(msg) > 1) ? strlen(msg) : 2)  == 0) {
              flag = FALSE;
           }
           else {
#ifdef VXWORKS
	     taskSpawn("askc",50,0,20000,(FUNCPTR)askp1,proc_name,msg);
#else
	     Send_Message(proc_name,msg);
#endif
           if (strncasecmp(msg, "EXIT",
                     (strlen(msg) > 1) ? strlen(msg) : 2)  == 0)
              flag = FALSE;
           }
#ifndef VXWORKS
           sleep(1);
#endif
        }
#ifndef VXWORKS
        sleep(1);
#endif
     }
/*                                       */
/* if the string is a single command     */
/*                                       */
  else { 

      j = argc;
      for (i = 2 ; i < j ; i ++) {
          strcat(msg , argv[i]);
          strcat(msg, " ");
      }

      if (debug_level >= 20) {
         printf("proc_name = %s\n ",proc_name);
         printf("in_string = %s\n",msg);
      }
#ifdef VXWORKS
      taskSpawn("askc",50,0,20000,(FUNCPTR)askp1,proc_name,msg);
#else
      Send_Message(proc_name,msg);
#endif
   }
}
#ifdef VXWORKS
void askp1(nm,ms)
char *nm,*ms;
{
  strcpy(ownpname, "user");

  if (Attach_Table() == -1)
    printf("Error in Create_Table()\n");
  rpc_init();
  Send_Message(nm,ms);
}
#endif

