/*************************************************
 * CVS Log
 * cc_config.h,v
 * Revision 1.1.1.1  1993/07/14  19:42:29  dbrenner
 * UNIDAQ 2.1 distribution - July 14,1993
 *
*************************************************/
/* File name     : cc_config.h
 * Creation date : July 1992
 * Author        : Y.Yasu, Online group, Physics department, KEK
 */

/* Timeout Time */
#define CC_K_TIMEOUT_LAM        60 /* LAM : 60 sec. */
#define CC_K_TIMEOUT_DONE       5  /* DMA DONE : 5 sec.  */
#define CC_K_TIMEOUT_COUNT      1000 /* single action timeout : loop count */

/* For List Processing */
#define CC_LIST_MAX_STEP        100000000
#define CC_LIST_MAX_LENGTH      20000
#define CC_LIST_MAX_DATA	256	/* max len of data  64kw */

/* For Kinetics List Processing */
#define CC_KLIST_MAX_DIR	1000	/* max number of K2917 lists */

/* debug options */
/*
#define DEBUG
#define CC_DEBUG_LEVEL 10
#define DEBUG_LIST
*/
