/*
 * nv_pause.c
 *                 novasub rouitines
 *
 *              version 1.02  30-SEP-1992 Masaharu NOMACHI   (KEK)
 */

#include "novalib.h"
#include "nova.h"

int nova_pause(nd) struct NOVAD *nd; {
  int rval,pid;

  /*
   * send message to the buffer manager
   */
  nd->buffer->mtype = nd->snd_type;
  sprintf(nd->buffer->mtext,"pause+done:%d:%d:",nd->pid,nd->novaid);
#ifdef VXWORKS
  rval = msgQSend(nd->snd_msgid, nd->buffer->mtext, NV_MSGLEN, WAIT_FOREVER,
         MSG_PRI_NORMAL);
#else
  rval = msgsnd(nd->snd_msgid, nd->buffer, NV_MSGLEN, 0);
#endif
  if (rval < 0) {
    perror("nv_pause: send message");
    return -1;
  }
  nd->request = 0;
  return 0;
}

