/*************************************************
 * shutdown.c,v
*************************************************/
/*---------------------------------------------------------------*/
/*                                                               */
/*      Cengiz ERBAS                                             */
/*      Superconducting Super Collider Laboratory                */
/*      June 20, 1992                                            */
/*                                                               */
/*---------------------------------------------------------------*/

/************************************************************************
*                                                                       *
* Copyright (c) 1993                                                    *
* The Regents of The University of Michigan                             *
* Universities Research Association, Inc.                               *
* All Rights Reserved                                                   *
*                                                                       *
*                Authors:                                               *
*                        R. Ball, C. Timmermans, UofM                   *
*                        Y. Takeuchi, T.I.T.                            *
*                        M. Nomachi, KEK                                *
*                        A. Fry, C. Erbas, D. Brenner, SSCL             *
*                                                                       *
************************************************************************/

#include <stdio.h>
#include <sys/types.h>
#include <errno.h>
#include "template.h"

/*(a+out) ------------------------------------------------- */
main (argc, argv)
int argc;
char *argv[];
/*(b+out) ------------------------------------------------- 
Procedure Name
Main - main procedure of shutdown
Synopsis
Description
main() is the main procedure of shutdown.  Shutdown deteles the
common table.  It calls Attach_Table and Delete_Table.

Superconducting Super Collider Laboratory 1.0
(c+out) --------------------------------------------------- */

{
   if (Attach_Table() == -1)
      printf("Error in Create_Table()\n");

   if (Delete_Table() == -1)
      printf("Error in Create_Table()\n");

   printf("Common Table deleted...\n");
}

