c   $USERUNIDAQ/analyzer/analyzer.d/pawmain.f
c
*---------------------------------------------------------------*/
*                                                               */
*      Cengiz ERBAS                                             */
*      Superconducting Super Collider Laboratory                */
*      July 14, 1992                                            */
*                                                               */
*---------------------------------------------------------------*/

*************************************************************************
*                                                                       *
* Copyright (c) 1993                                                    *
* The Regents of The University of Michigan                             *
* Universities Research Association, Inc.                               *
* All Rights Reserved                                                   *
*                                                                       *
*                Authors:                                               *
*                        R. Ball, C. Timmermans, UofM                   *
*                        Y. Takeuchi, T.I.T.                            *
*                        M. Nomachi, KEK                                *
*                        A. Fry, C. Erbas, D. Brenner, SSCL             *
*                                                                       *
*************************************************************************

      SUBROUTINE PAW_INIT
      PARAMETER (NWPAW=500000)
      PARAMETER (NWHIGZ=10000,NWKUIP=75000)
      COMMON/PAWC/H(NWPAW)
*      print *, 'call pawint'
      CALL PAWINT(NWPAW,NWHIGZ,NWKUIP)
*      print *,' call kuexec'
      CALL KUEXEC('LAST 0')
      CALL KUEXEC('ZONE 1 1')
      CALL KUEXEC('set/root analyzer')

      RETURN 
      END


      SUBROUTINE PAW_EXEC (COMMAND)
      CHARACTER*100 COMMAND
      CALL KUEXEC(COMMAND)
      RETURN
      END


      SUBROUTINE PAW_EXIT
      CALL PAEXIT
      RETURN
      END

      subroutine pawusr(itran)
      if (itran .eq. 1) then
         print 3000
         call anadef
      end if
*
 3000 FORMAT(' ******************************************************'/
     +      ,' *                                                    *'/
     +      ,' *        For ANALYZER / UNIDAQ version 2.3           *'/
     +      ,' *                                                    *'/
     +      ,' ******************************************************')
      end

      subroutine igwkty(iwk)
      iwk = 1
      end

      SUBROUTINE VERTIM(IDWARN,IDSTOP)
      END
