	subroutine paw_init()
	end
      SUBROUTINE PAW_EXEC (COMMAND)
      CHARACTER*100 COMMAND
      CALL KUEXEC(COMMAND)
      RETURN
      END


      SUBROUTINE PAW_EXIT
      CALL PAEXIT
      RETURN
      END

      subroutine pawusr(itran)
      if (itran .eq. 1) then
         print 3000
         call unidef
      end if
*
 3000 FORMAT(' ******************************************************'/
     +      ,' *                                                    *'/
     +      ,' *       For ANALYZER_TOOL / UNIDAQ version 2.3       *'/
     +      ,' *                                                    *'/
     +      ,' ******************************************************')
      end

      subroutine igwkty(iwk)
      iwk = 1
      end

      SUBROUTINE VERTIM(IDWARN,IDSTOP)
      END

*
*  Above are UNIDAQ specific routines.  Below are PAW specific.  Those below 
*  are taken from the 93d distribution.  Two versions are provided, that for 
*  HPUX (this one) and that for other machines.
*
CDECK  ID>, BLANKDEK.   
*CMZ :  2.03/09 07/09/93  12.07.58  by  Rene Brun
*-- Author :
CDECK  ID>, 0PAMAIN.
*CMZ :  2.03/09 07/09/93  18.49.13  by  Rene Brun
*-- Author :    Rene Brun   03/01/89
      PROGRAM PAMAIN
*
*CMZ :  2.02/05 02/06/93  10.20.24  by  Rene Brun
*-- Author :
      COMMON/PCARGS/NOLOG,BATCH
      LOGICAL NOLOG,BATCH
*
*CMZ :  2.02/00 13/04/93  18.00.47  by  Rene Brun
*-- Author :
*CMZ :  2.02/02 25/05/93  19.17.20  by  Rene Brun
*-- Author :
      PARAMETER (NWPAW=2000000)
*

*
      PARAMETER (NWHIGZ=10000,NWKUIP=5000)
      COMMON/PAWC/PAW(NWPAW)
      CHARACTER*80  BATCHF, LOGFIL
      LOGICAL       EXIST1, EXIST2
*CMZ :  2.02/00 13/04/93  18.00.48  by  Rene Brun
*-- Author :
*CMZ :  2.02/00 13/04/93  18.00.48  by  Rene Brun
*-- Author :
      CHARACTER*255 PAWSYS,PAWLOG
       DATA PAWSYS/'/cern/pro/bin/pawsys.kumac'/
       DATA PAWLOG/'pawlogon.kumac'/
*

*
*
*            Batch or Interactive version ?
*
      BATCHF = ' '
      CALL KUARGS('PAW',PAWLOG,BATCHF,LOGFIL,IERR)
      IF (IERR .NE. 0) GOTO 999
*
      EXIST1=.FALSE.
      INQUIRE(FILE=PAWSYS,EXIST=EXIST1)
      NOLOG=.FALSE.
      BATCH=.FALSE.
      IF (BATCHF.NE.' ') BATCH = .TRUE.
      IF (PAWLOG.EQ.' ') NOLOG = .TRUE.
*
      CALL PAWINT(NWPAW,NWHIGZ,NWKUIP)
*
      LPAW   = LENOCC(PAWLOG)
*
*            Change default prompt
*
      CALL KUEXEC('SET/PROMPT ''PAW >''')
*
*        Execute SYSTEM logon macro containing messages
*        about new PAW features etc.
*        Should find a standard place for this file!
*
      IF (EXIST1) CALL KUEXEC('EXEC '//PAWSYS)
*
      IF (.NOT.NOLOG) THEN
*
*           Execute LOGON macro
*
         LPAW   = LENOCC(PAWLOG)
         INQUIRE(FILE=PAWLOG(1:LPAW),EXIST=EXIST1)
         IF (.NOT. EXIST1) THEN
            PAWLOG = '~/.pawlogon.kumac'
            LPAW=LENOCC(PAWLOG)
            CALL KUHOME(PAWLOG,LPAW)
            INQUIRE(FILE=PAWLOG(1:LPAW), EXIST=EXIST2)
            IF (.NOT. EXIST2) THEN
               NOLOG = .TRUE.
               PRINT 10100, PAWLOG(1:LPAW)
            ELSE
               PRINT 10300, PAWLOG(1:LPAW)
            ENDIF
         ENDIF
      ENDIF
      IF (.NOT.NOLOG) CALL KUEXEC('EXEC '//PAWLOG(1:LPAW))
*
*            Reset history
*
      CALL KUEXEC('LAST 0')
*
      IF(BATCH)THEN
         CALL KUEXEC('EXEC '//BATCHF)
      ELSE
         CALL KUWHAG
      ENDIF
*
      CALL PAEXIT
 999  CONTINUE
      STOP
10100 FORMAT(' *** No default PAWLOGON file "',A,'" found',/)
10200 FORMAT(' *** No default PAWLOGON file defined via "',A,'"',/)
10300 FORMAT(' *** Using default PAWLOGON file "',A,'"',/)
      END
      SUBROUTINE QNEXT
      END
